function [fNbestArray,thetaBestArray,pBestArray,alpha_t_Array,...
    tp,tn,threshold] = ...
        TrainAdaB_stage(T,test_ratio,NFidx,targetTP,targetFP)
%[fNbestArray,thetaBestArray,pBestArray,alpha_t_Array,tp,tn,threshold] =
% TrainAdaB_stage(T,test_ratio,NFidx,targetTP,targetFP)
%
% Takes the desired number of weak classifiers (T), the testdata to
% training data ratio (test_ratio) and the non-face indices (NFidx) as well
% as the desired true-positive rate (targetTP) and false-positive rate
% (targetFP) and returns the stage selected: 
% (fNbestArray,thetaBestArray,pBestArray,alpha_t_Array,tp,tn,threshold)


verbose = 1;
cropsize = 19;

patchi=cropsize; % CHANGE THIS FOR OTHER IMAGE WINDOWS
fpath=which(mfilename); pathMF = fpath(1:findstr(upper(mfilename),upper(fpath))-1);
load('images.mat');
load('features.mat');
load('BestF.mat');

%generate = 1;
%if generate
%clear all
fN=size(f,2);   % num of features
%actual_f = bestF(1:100);
%actual_f = bestF;
actual_f=1:fN;%[]; for i=1:fN, if sum(abs(f(:,i)))~=0, actual_f=[actual_f i]; end, end  % find features that are not singular!
%actual_f=[]; for i=1:fN, if sum(abs(f(:,i)))~=0, actual_f=[actual_f i]; end, end  % find features that are not singular!
numFaces = size(cumFaces,1);
numNonFaces = length(NFidx);
F_randindx=randperm(numFaces);       % shuffle index for the images!
NF_randindx=randperm(numNonFaces);       % shuffle index for the images!
test_part=test_ratio;   % the ratio of test_data to all_data, change this if you like!
num_testp=round(test_part*numFaces);
num_testn=round(test_part*numNonFaces);
num_trainp=numFaces-num_testp;
num_trainn=numNonFaces-num_testn;

% SECTION 1 %
%%%%%%%%%%%%%%%  TRAINING DATA  %%%%%%%%%%%%%%%%%%%%
x_train=[...
    cumFaces(F_randindx(1:num_trainp),:); ...
    cumNonFaces(NFidx(NF_randindx(1:num_trainn)),:)];      % matrix with each row being one of the train images,
y_train=[ones(1,num_trainp) zeros(1,num_trainn)];  % 1/0 for face/nonface - same pos as weights
%decide here which ones you want to keep for testing (if
%you want to do that internally)
%%%%%%%%%%%%%%%  TESTING DATA  %%%%%%%%%%%%%%%%%%%%
x_test=[...
    cumFaces(F_randindx(num_trainp+1:end),:); ...
    cumNonFaces(NFidx(NF_randindx(num_trainn+1:end)),:)];      % matrix with each row being one of the train images,
y_test=[ones(1,num_testp) zeros(1,num_testn)];
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%disp(sprintf('# train_faces %d, # train_nonfaces %d',num_trainp,num_trainn))
%disp(sprintf('# test_faces %d, # test_nonfaces %d',num_testp,num_testn))


fNbest=0;


% SECTION 2 %
%%%%%%%%%%%%%%%% INITIALIZE WEIGHTS %%%%%%%%%%%%%%%%%
faceWratio = 0.6;
wface=faceWratio/num_trainp;
wnonface=(1-faceWratio)/num_trainn;
w=[wface*ones(1,num_trainp) wnonface*ones(1,num_trainn)]; % form a weight vector
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



%%%%%%%%%%%%%%%% TRAINING DATA ARRAYS %%%%%%%%%%%%%%%%%%
faces=[];
nofaces=[];
fN=size(f,2);   % num of features
thetaArray=zeros(1,fN); %thetaArray=[];
pArray=zeros(1,fN);     %pArray=[];

fNbestArray=[];
alpha_t_Array=[];
minErrorArray=[];
thetaBestArray=[];
pBestArray=[];
%[fid msg]=fopen([pathMF 'trg_res.txt'],'a');     %store in text file
clk=clock;
%disp(fprintf(fid,'--%s %d:%d %s\r\n',date,clk(4),clk(5),'V&J'));
%fclose(fid);

Nactual = length(actual_f);
%disp(sprintf('%d iters, %d features per iter',T, Nactual))   % printing is slow...

smallSet = randperm(fN);
smallSet = smallSet(1:5000);
%%%%%%%%%%%%%%%%% THE ADABOOST ITERATIONS STEPS %%%%%%%%%%%%%%%%%%%%
count=0; errcond = 0;   % for all kinds of strange errorss
for t=1:T

    % SECTION 3 %
    %%%%%%%%%%%%%%%%%%%% WEIGHT NORMALIZATION %%%%%%%%%%%%%%%%%%%%%%%%
    w =                                   % Normalize weights

    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


    minError= inf;
    %[fid msg]=fopen([pathMF 'trg_res.txt'],'a');     %store in text file
    %for fNcount=smallSet;%actual_f
    fNcount = 0;
    for fI=actual_f
        fNcount = fNcount + 1;
        fout=x_train*f(:,fI);        % feature value for all samples - vectorised so that NO for-loops needed!

        % SECTION 4 %
        %%%%%%%%%%%%%%%%%%% CLASSIFIER THRESHOLDING %%%%%%%%%%%%%%%%%%%%%
        [theta,p]= findThreshold(fout,w(1:num_trainp),w(num_trainp+1:end));    % <-----  Write this function!
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

        %Check if x is classified correctly
        posComp = fout*p < theta*p;
        err_classify = [~posComp(1:num_trainp); posComp(num_trainp+1:end)];

        % SECTION 5 %
        %%%%%%%%%%%%%%%%%%%% BEST FEATURE UPDATE %%%%%%%%%%%%%%%%%%%%%%%%
        Error = 
        % if lower error, take note
        if Error < minError
            minError = Error;
            fNbest = fI;
            thetaBest = theta;
            pBest = p;
            misclassify_vec = err_classify;
        end
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

        if mod(fNcount,100)==0
            disp(sprintf('  Feat %d iter %d',fNcount,t));   % printing is slow...
        end

    end

    % SECTION 6 %
    %%%%%%%%%%%%%%%%%%%% WEIGHT UPDATE %%%%%%%%%%%%%%%%%%%%%%%%
    beta_t = 
    if beta_t ~= 0
        alpha_t = 
    else
        alpha_t = 
    end
    wc = 
    w =                             % reduce weight if correct
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

    count = count+1;    % how many were actually generated
    fNbestArray=[fNbestArray fNbest];
    minErrorArray=[minErrorArray minError];
    thetaBestArray=[thetaBestArray thetaBest];
    alpha_t_Array=[alpha_t_Array alpha_t];
    pBestArray=[pBestArray pBest];
 %   disp(fprintf(fid,'%4.0f %4.2f %3.3f \r\n',fNbest, thetaBest, minError));
 %   disp(sprintf('%4.0f %4.2f %3.3f \r\n',fNbest, thetaBest, minError));
  %  fclose(fid);
    
    actual_f=actual_f(actual_f~=fNbest);  % exclude the found feature in future iterations
    % SECTION 7 %
    %%%%%%%%%%%%%%%%%%% TESTING ON VALIDATION DATA %%%%%%%%%%%%%%%%%%%%
    [tp,tn,threshold] = TestStage(fNbestArray,thetaBestArray,pBestArray,alpha_t_Array,x_test,y_test,targetTP);
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    disp(sprintf('    fp=%.2g', 1-tn));
    if 1-tn <= targetFP
        break;
    end
end
T=count;
clk=clock;


if verbose
    figure(4);
    clf;
    for i=1:T
        box=DisplayFeature(patchi,patchi,f(:,fNbestArray(i)));
        subplot(ceil(sqrt(T)),ceil(sqrt(T)),i); 
        imagesc(-pBestArray(i)*box); colormap(gray); axis equal;
        title(['feature ' num2str(fNbestArray(i))]);
    end
    figure(5);
    clf;
    show_classifier(fNbestArray, pBestArray, alpha_t_Array, 0);
end    
    


