function falsePosIdx = findFP...
    (fNbestArray,thetaBestArray,pBestArray,alpha_t_Array,x,selectedThrRat)
% falsePosIdx = findFP(fNbestArray,thetaBestArray,pBestArray,alpha_t_Array,x,selectedThrRat)
%
% Finds the indices of FP classifications amongst the data x, given
% the stage with features f(:,fNbestArray), with thresholds thetaBestArray,
% parities pBestArray and alpha-values alpha_t_Array.
% selectedThrRat is the coefficient infront of the threshold of the strong
% classifier. (usually in theory selectedThrRat = 0.5)


load('features.mat');
nNonFace = size(x,1);

T = length(fNbestArray);   % num of features
%initialisation:
hValue = 0; 
for t = 1: T
    ht = x*f(:,fNbestArray(t))*pBestArray(t) < ...
        thetaBestArray(t)*pBestArray(t);
    hValue = hValue + alpha_t_Array(t)*ht;
end
hThreshold = sum(alpha_t_Array);
incorrect = hValue >= selectedThrRat*hThreshold;
falsePosIdx = find(incorrect);
