function show_classifier(fN,p,alpha_t,test)
%  show_classifier(fN,p,alpha_t,test)
%
% Displays a superpositions of all features in fN (indices of features),
% with the parities p and weights alpha_t. 
% If the flag test==1 the test features stored in t_features.mat will be
% used instead.

if test==1
    load('t_features.mat');
else
    load('features.mat');
end

boxen=zeros(19,19);

for i=1:length(alpha_t)
    box = DisplayFeature(19,19,f(:,fN(i)));
    boxen=boxen-alpha_t(i)*p(i)*box;
end

imagesc(boxen);
colormap(gray);
axis equal;