function [F, Fidx, Pidx] = simpleboxeszero(nI,nJ);
%function [F, Fidx, Pidx] = simpleboxeszero(nI,nJ);
%
% Create set of features which are the coords of various sizes of rectangle
% in patch of image, nI, nJ in size.


nI = nI+1;nJ=nJ+1;              % integral image considerations
nPidx = nI*nJ;
nSidx = 1/4*nI*(nI-1)*nJ*(nJ-1);
% allocate sparse matrix
% Create matrix - increasing numbers in a column [1 2 3...; 25 26 27...;]'
Pidx = reshape(1:nPidx,nI,nJ);  % convert 1D into 2D
% Fidx - will hold an index pointing to F. To reach it, specify:
%   a PAIR of r,c coords representing the top left/bottom right of a rectangle.
%   EACH r,c coord is converted into r+c*nJ 1D form. So two Fidx entries will point to F.
Fidx = zeros(nPidx,nPidx);
% F - each col is vector -  AT the coords of corners, has values of coeffs
%F = sparse([],[],[],nI*nJ,nI*nJ,ceil(nI*nJ/2));
F = sparse(nPidx,nSidx); 
sidx = 0;   % serial number of feature
for rs = 1:nI-1      % size of rect - row
    for cs = 1:nJ-1       % and col
        % translate rects of size rs&cs across ALL positions in patch
        for ctl = 1: nJ-cs    % coords of top left col
            for rtl = 1: nI-rs    % & row
                sidx=sidx+1;
                cbr = ctl + cs;     % bottom right col
                rbr = rtl + rs;     % and row
                %sprintf('TL %d %d BR %d %d Pidx %d %d', rtl,ctl,rbr,cbr,Pidx(rtl,ctl),Pidx(rbr,cbr))
                Fidx(Pidx(rtl,ctl),Pidx(rbr,cbr)) = sidx;
                % coeffs to +/-
                F(Pidx(rtl,ctl),sidx)=1;    % top left
                F(Pidx(rbr,ctl),sidx)=-1;   % bottom left
                F(Pidx(rtl,cbr),sidx)=-1;   % and right
                F(Pidx(rbr,cbr),sidx)=1;   % and right
            end
        end
    end
end
% rect size translates ???
% 1x1 = 1,1 -> 24,24    2x1 = 1,1 -> 23,24
% 1x2 = 1,1 -> 24,23    2x2 = 1,1 -> 23,23
%
